KNewStuffSecure Class Referenceabstract

`#include <knewstuffsecure.h>`

Inheritance diagram for KNewStuffSecure:

## Signals

void | installFinished ()

## Public Member Functions

| KNewStuffSecure (const QString &type, QWidget *parentWidget=0)
bool | install (const QString &fileName)
bool | createUploadFile (const QString &fileName)
void | downloadResource ()
void | uploadResource (const QString &fileName)
Public Member Functions inherited from KNewStuff
| KNewStuff (const QString &type, QWidget *parentWidget=0)
| KNewStuff (const QString &type, const QString &providerList, QWidget *parentWidget=0)
QString | type () const
QWidget * | parentWidget () const
void | download ()
void | upload ()
void | upload (const QString &fileName, const QString previewName)
virtual QString | downloadDestination (KNS::Entry *entry)

## Protected Member Functions

virtual void | installResource ()=0
void | removeTempDirectory ()
Protected Member Functions inherited from KNewStuff
KNS::Engine * | engine ()

## Protected Attributes

KTempDir * | m_tempDir
QString | m_tarName
QString | m_signedFileName
QMap< QString, QString > | m_installedResources

## Detailed Description

Makes possible downloading and installing signed resource files from a server.

You must subclass it and implement the installResource() pure virtual method to install a resource. For uploading you must create a resource tarball (which is installabale by installResource()) and call the uploadResource() method with this tarball as the argument. Signing and verification is done by the gpg application, so the user must have it installed, otherwise this class does not give any extra security compared to the standard KNewStuff class.

Since
  3.4

Author
  Andras Mantia amant.nosp@m.ia@k.nosp@m.de.or.nosp@m.g

Definition at line 40 of file knewstuffsecure.h.

## Constructor & Destructor Documentation

KNewStuffSecure::KNewStuffSecure | ( | const QString & | type,
|  | QWidget * | parentWidget = `0`
| ) |  |

Constructor.

Parameters

  type | type of data to be handled, should be something like korganizer/calendar, kword/template, kdesktop/wallpaper
  parentWidget | parent widget of dialogs opened by the KNewStuff engine

Definition at line 36 of file knewstuffsecure.cpp.

## Member Function Documentation

bool KNewStuffSecure::createUploadFile | ( | const QString & | fileName | ) |

virtual

Reimplemented for internal reasons.

Implements KNewStuff.

Definition at line 168 of file knewstuffsecure.cpp.

void KNewStuffSecure::downloadResource | ( |  | ) |

Initiates a download.

This is the method that must be called in order to download a signed resource.

Definition at line 160 of file knewstuffsecure.cpp.

bool KNewStuffSecure::install | ( | const QString & | fileName | ) |

virtual

Installs the downloaded resource.

Do not call or reimplement directly. It's reimplemented from KNewStuff for internal reasons.

Implements KNewStuff.

Definition at line 49 of file knewstuffsecure.cpp.

virtual void KNewStuffSecure::installResource | ( |  | ) |

protected pure virtual

Installs the resource specified by m_tarName.

Implement it in the subclass.

void KNewStuffSecure::removeTempDirectory | ( |  | ) |

protected

Removes the temporary directory m_tempDir.

Definition at line 230 of file knewstuffsecure.cpp.

void KNewStuffSecure::uploadResource | ( | const QString & | fileName | ) |

Signs the file and uploads to the central server.

Parameters

  fileName | The file to be signed and uploaded

Definition at line 174 of file knewstuffsecure.cpp.

The documentation for this class was generated from the following files:

- knewstuffsecure.h
- knewstuffsecure.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys